/**
 * IrcResponder - Interacts with users via IRC
 *
 * @author	Jonathan Roewen
 */
#ifndef IRC_RESPONDER_H
#define IRC_RESPONDER_H

#include "Responder.h"
#include "Socket.h"

#include <queue>

using namespace std;

class IrcResponder : public Responder, public SocketListener {
public:
	IrcResponder(const string &, const int &, const string &, const string &);
	~IrcResponder();
	
	string respond(Match *, PElement, const string &);
	
	void execute();
	
	//////////
	
	void process();
	void sendCommand(const string &);
	void received(string &);
	void send(const string &);
	void connect(const string &, const string &);
	void disconnect();
private:
	string server, nick, channel, buffer, lastnick;
	int port;
	Socket *sock;
	queue<string> q;
};

#endif	//	IRC_RESPONDER_H