/**
 * Kernel - Brains of the operation
 *
 * @author	Jonathan Roewen
 */
#ifndef KERNEL_H
#define KERNEL_H

#include <string>

using namespace std;

#include "Element.h"	//	?

class Match;

class Responder;
class Nodemapper;
class StringTokenizer;

class Kernel
{
public:
	Kernel();

	static void load(const string &file);
	static void load10(const string &file, PElement &root);
	static Nodemapper *add(const string &pattern, const string &that, const string &topic);
	static Nodemapper *add(const string &sentence, Nodemapper *parent);
	static Nodemapper *add(StringTokenizer &st, Nodemapper *parent, int count, const string &sentence);
	static Match *match(const string &input, const string &that, const string &topic);
	static Match *match(Nodemapper *node, Nodemapper *parent, const string &input, const string &star, const string &path);
	static string process(Match *m, PElement e, Responder *, const string &id);
	static string respond(const string &input, const string &id);
	static string respond(const string &input, const string &id, bool srai);
	static string respond(const string &input, const string &id, Responder *);
	static string respond(const string &input, const string &id, int depth, bool srai);
	static string respond(const string &input, const string &id, Responder *, int depth, bool srai);
private:
	static Nodemapper *root;
};

#endif 