/**
 * LearnProcessor - Learns AIML files (for now)
 *
 * @author	Jonathan Roewen
 */
#ifndef LEARN_PROCESSOR_H
#define LEARN_PROCESSOR_H

#include "AimlProcessor.h"
#include "Substituter.h"
#include "Parser.h"
#include "Kernel.h"

#include <string>
#include <fstream>
#include <strstream>

using namespace std;

class LearnProcessor : public AimlProcessor
{
public:
	~LearnProcessor() { }
	
	string getName() const {
		return "learn";
	}
	string getVersion() const {
		return "1.0";
	}
	string process(Match *m, PElement e, Responder *r, const string &id) {
		PElement pattern = e->getChild("pattern");
		if (pattern == PElement()) {
			//	<learn> a file
			string name = Kernel::process(m, e, r, id);
			Kernel::load(name);
		} else {
			//	<learn> new AIML defined in a <pattern>
			
			//	This needs fixing!
			//	Need to process template, do an output substitution
			//	to change &lt; etc into '<' etc
			//	then parse it...
		//	PElement temp = e->getChild("template");
		/******************************************/
			strstream ss;
			string str = "<template>" + Kernel::process(m, e->getChild("template"), r, id) + "</template>";
			cout << Substituter::output(str) << endl;
			ss << Substituter::output(str) << endl;
			Parser *p = new Parser();
			PElement temp = p->parse(ss, "template");
		/******************************************/
			//	Need to do something similar with <pattern>
			strstream s2;
			string str2 = "<pattern>" + Kernel::process(m, e->getChild("pattern"), r, id) + "</pattern>";
			s2 << str2 << endl;
			pattern = p->parse(s2, "template");
			PElement that = e->getChild("that");
			//	g-o-d's double learning won't work with this yet
			PElement category(new Element("category"));
			category->addChild(pattern);
			category->addChild(temp);
			if (that != PElement()) {
				category->addChild(that);
			}
			PElement root(new Element("aiml"));
			root->addChild(category);
			Kernel::load10("~temporary memory area~", root);
			//	Now just need to write to a file...
		}
		return "";
	}
};

#endif