/**
 * Nodemaster - The real nodemapper ;-)
 *
 * @author	Jonathan Roewen
 */
#include "Nodemaster.h"

extern long totalSize;
extern long totalNodes;

Nodemapper *Nodemaster::getChild(const string &key) {
	if (children.find(key) == children.end()) {
		return NULL;
	}
	return (*children.find(key)).second;
}

void Nodemaster::addChild(const string &key, Nodemapper *value) {
	children[key] = value;
	++totalNodes;
}

string Nodemaster::getTemplate() {
	if (templates.empty()) {
		return "";
	}
	if (templates.size() == 1) {
		return templates[0];
	}
	lastIndex = rand() % templates.size();
	return templates[lastIndex];
//return templates;
}

void Nodemaster::addTemplate(const string &value) {
	totalSize += (value.length() * sizeof(char)) + sizeof(string);
	templates.push_back(value);
//templates = value;
}

string Nodemaster::getAuthor() {
	if (authors.empty()) {
		return "";
	}
	if (authors.size() > lastIndex) {
		return authors[lastIndex];
	}
	return authors[0];
//return "j-alice";
}

void Nodemaster::addAuthor(const string &value) {
	totalSize += (value.length() * sizeof(char)) + sizeof(string);
	authors.push_back(value);
}

string Nodemaster::getFilename() {
	if (filenames.empty()) {
		return "";
	}
	if (filenames.size() > lastIndex) {
		return filenames[lastIndex];
	}
	return filenames[0];
//return "unknown";
}

void Nodemaster::addFilename(const string &value) {
	totalSize += (value.length() * sizeof(char)) + sizeof(string);
	filenames.push_back(value);
}