/**
 * Nodemaster - The real nodemapper ;-)
 *
 * @author	Jonathan Roewen
 */
#ifndef NODEMASTER_H
#define NODEMASTER_H

#include <map>
#include <vector>

using namespace std;

#include <time.h>
#include <stdlib.h>

#include "Nodemapper.h"

class Nodemaster : public Nodemapper
{
public:
	Nodemaster() : lastIndex(0) {
		srand(time(NULL));
	}
	~Nodemaster() { }
	
	Nodemapper *getChild(const string &);
	void addChild(const string &, Nodemapper *);
	string getTemplate();
	void addTemplate(const string &);
	string getAuthor();
	void addAuthor(const string &);
	string getFilename();
	void addFilename(const string &);
private:
	map<string, Nodemapper *> children;
	vector<string> templates;
	vector<string> authors, filenames;
//string templates;	
	unsigned int lastIndex;
};

#endif  